;; clari.el -- remove annoying _^H's and replace with underlined characters.
;; rather blatant port from Lucid version... all I did really was to
;; transform extents to overlays.
;;
;; to use:
;; put (load "clari.el") in your .emacs
;;
;; Erik Selberg
;; speed@cs.washington.edu

(make-face 'gnus-underline)
(or (face-differs-from-default-p 'gnus-underline)
    (set-face-underline-p 'gnus-underline t))

(defun gnus-hack-underlining ()
  "replaces underscore-backspace with an extent.
Also removes the extra blank lines from the article."
  (save-excursion
    (set-buffer gnus-article-buffer)
    (goto-char (point-min))
    (while (re-search-forward "\\(\\(_\^H.\\) ?\\)+" nil t)
      (overlay-put (make-overlay (match-beginning 0) (match-end 0))
		   'face 'gnus-underline))
    (goto-char (point-min))
    (while (re-search-forward "_\^H" nil t) (replace-match ""))))

(defun gnus-hack-clarinews ()
  (if (string-match "^clari\\.*\\|^biz\\.clarinet" gnus-newsgroup-name)
      (save-excursion
	(gnus-hack-underlining)
	(set-buffer gnus-article-buffer)
	(goto-char (point-min))
        (while (re-search-forward "\n\n\n\n*" nil t)
          (replace-match "\n\n")))))

(add-hook 'gnus-article-prepare-hook 'gnus-hack-clarinews)

;; --- end of clari.el
